--Minetest
--Copyright (C) 2013 sapier
--
--This program is free software; you can redistribute it and/or modify
--it under the terms of the GNU Lesser General Public License as published by
--the Free Software Foundation; either version 2.1 of the License, or
--(at your option) any later version.
--
--This program is distributed in the hope that it will be useful,
--but WITHOUT ANY WARRANTY; without even the implied warranty of
--MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--GNU Lesser General Public License for more details.
--
--You should have received a copy of the GNU Lesser General Public License along
--with this program; if not, write to the Free Software Foundation, Inc.,
--51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

--------------------------------------------------------------------------------

isCutom = false

local function get_formspec(tabview, name, tabdata)

	local menu_background = defaulttexturedir .. "background_trees.png"
	local classic_def = defaulttexturedir .. "classic_def.png"
	local classic_put = defaulttexturedir .. "classic_put.png"
	local creative_def = defaulttexturedir .. "creative_def.png"
	local creative_put = defaulttexturedir .. "creative_put.png"
	local reset_def = defaulttexturedir .. "reset_def.png"
	local reset_put = defaulttexturedir .. "reset_put.png"
	local title = defaulttexturedir .. "title.png"
	local license = defaulttexturedir .. "license.png"
	
	local retval = 
		"image_button[4.88,3.5;6.25,1.95;" .. classic_def .. ";btn_classic;;false;false;" .. classic_put .. "]" ..
		"image_button[4.88,5.5;6.25,1.95;" .. creative_def .. ";btn_creative;;false;false;" .. creative_put .. "]" ..
		"image_button[0,8;3.5,1.75;" ..reset_def .. ";btn_reset;;false;false;" .. reset_put .. "]" ..
		"image_button[0.5,0;15,3;" .. title .. ";title;;false;false;" .. title .. "]" ..
		"image_button[5,9.5;6,1;" .. license .. ";title;;false;false;" .. license .. "]"

	return retval
end

local function reset_world(name)
	local world_list = core.get_worlds()

	for i,world in pairs(world_list) do
		if world.name == name then
			core.delete_world(i)
			break
		end
	end

end

local function play_world(name)
	local world_list = core.get_worlds()
	local found_world = false

	for i,world in pairs(world_list) do
		if world.name == name then
			found_world = true
			gamedata.worldindex = i
			break
		end
	end

	if not found_world then
		core.setting_set("fixed_map_seed", math.floor(math.random()*100000000000000 + 1));
		core.create_world(name, 1)
		world_list = core.get_worlds()
		for i,world in pairs(world_list) do
			if world.name == name then
				gamedata.worldindex = i
				break
			end
		end
	end

	gamedata.singleplayer	= true
	gamedata.selected_world	= gamedata.worldindex
end

--------------------------------------------------------------------------------
local function main_button_handler(tabview, fields, name, tabdata)
	local tpath = core.get_texturepath()..DIR_DELIM.."tpack"
	if fields.btn_classic then
		core.setting_set("enable_damage", "true")
		core.setting_set("creative_mode", "false")
		core.setting_set("texture_path", tpath)

		play_world("freeworld")
		core.start()

		return true
	end

	if fields.btn_creative then
		core.setting_set("enable_damage", "false")
		core.setting_set("creative_mode", "true")
		core.setting_set("texture_path", tpath)

		play_world("freeworld")
		core.start()

		return true
	end

	if fields.btn_reset then
		reset_world("freeworld");
		return true
	end
end


--------------------------------------------------------------------------------
return {
	name = "main",
	caption = fgettext("main"),
	cbf_formspec = get_formspec,
	cbf_button_handler = main_button_handler
}
